	[bits 16]
	[org 0x8000]

	KERNEL_OFFSET equ 0x8800 	; origin plus 0x800, or 2048
	;; Variables have to go between 0x7e00 and 0x8000
	VBE_INFO equ 0x7e00

	;; Clear some registers, especially after es was changed to load from disk
	mov ax, 0x0000
	mov ds, ax
	mov es, ax
	mov ss, ax


	mov bx, MSG_REAL_MODE
	call print
	call print_nl

	call vbe_set_mode 			;Start setting up video

	mov ax, 0x0000
	mov ds, ax
	mov es, ax
	mov ss, ax

	call switch_to_pm ; disable interrupts, load GDT,  etc. Finally jumps to 'BEGIN_PM'
	jmp $ ; Never executed


	%include "boot/print.asm"
	%include "boot/print_hex.asm"
	%include "boot/video.asm"
	%include "boot/gdt.asm"
	%include "boot/32bit_print.asm"
	%include "boot/switch_pm.asm"

	MSG_REAL_MODE db "Started in 16-bit Real Mode", 0
	MSG_PROT_MODE db "Landed in 32-bit Protected Mode", 0
	MSG_LOAD_KERNEL db "Loading kernel into memory", 0
	MSG_RETURNED_KERNEL db "Returned from kernel. Error?", 0
	MSG_VIDEO_ERROR db "VESA_ERR", 0

	[bits 16] 					;Just in case
error:
	mov bx, MSG_VIDEO_ERROR
	call print
	jmp $
	
	[bits 32]
BEGIN_PM:
	;; Set the A20 line
	in al, 0x92
	or al, 2
	out 0x92, al
	
	mov ebx, MSG_PROT_MODE
	call print_string_pm
	call KERNEL_OFFSET; Give control to the kernel
	jmp $ ; Stay here when the kernel returns control to us (if ever)

times 2048 - ($-$$) db 0 ; This second stage can be up to 2KB, for now
