#include "string.h"

/**
 * K&R implementation
 */
void int_to_ascii(int n, char str[]) {
	int i, sign;
	if ((sign = n) < 0) n = -n;
	i = 0;
	do {
		str[i++] = n % 10 + '0';
	} while ((n /= 10) > 0);

	if (sign < 0) str[i++] = '-';
	str[i] = '\0';

	reverse(str);
}

/* K&R */
void reverse(char s[]) {
	int c, i, j;
	for (i = 0, j = strlen(s)-1; i < j; i++, j--) {
		c = s[i];
		s[i] = s[j];
		s[j] = c;
	}
}

/* K&R */
int strlen(const char s[]) {
	int i = 0;
	while (s[i] != '\0') ++i;
	return i;
}

void append(char s[], char n) {
	int len = strlen(s);
	s[len] = n;
	s[len+1] = '\0';
}

void strappend(char *dest, const char *n)
{
	int len = strlen(n);
	int dlen = strlen(dest);
	for(int i = 0; i < len; i++)
	{
		dest[dlen + i] = n[i];
	}
	dest[dlen + len + 1] = '\0';
}

void backspace(char s[]) {
	int len = strlen(s);
	s[len-1] = '\0';
}

/* K&R
 * Returns <0 if s1<s2, 0 if s1==s2, >0 if s1>s2 */
int strcmp(char s1[], char s2[]) {
	int i;
	for (i = 0; s1[i] == s2[i]; i++) {
		if (s1[i] == '\0') return 0;
	}
	return s1[i] - s2[i];
}

//New stuff

//Splits a string into 2 at a separator
void strsplit(char *orig, char separator, char *a, char *b) {
	int found = 0;
	for(int i = 0; i < strlen(orig); i++) {
		if (orig[i] == separator && found == 0) found = i + 1; //+1 for the seperator char
		if (found > 0) {
			b[i - found] = orig[i];
		} else {
			a[i] = orig[i];
		}
	}
}

void tolowercase(char *in) {
	for(int i = 0; i < strlen(in); i++) {
		if(in[i] >= 65 && in[i] <= 90) {
			in[i] += 32;
		}
	}
}

void strcpy(char *dest, const char *src)
{
	int slen = strlen(src);
	
	for(int i = 0; i < slen; i++)
	{
		dest[i] = src[i];
	}
	dest[slen] = 0;
}

//Removes all occurances in the string
void strrem(char *dest, const char c)
{
	int dlen = strlen(dest);
	for(int i = 0; i < dlen; i++)
	{
		if(dest[i] == c)
		{
			dlen--;
			strcpy(dest + i, dest + i + 1);
			i--;
		}
	}
}
