#include "commands.h"
#include "terminal.h"
#include "../drivers/screen.h"
#include "../libc/function.h"
#include "../libc/string.h"
#include "../programs/texteditor.h"
#include "../drivers/floppy.h"
#include "../libc/mem.h"

void help(char *args)
{
	UNUSED(args);
	println("Not implemented yet :( you have to pester stephen");
}

void echo(char *args)
{
	println(args);
}

void clear(char *args)
{
	UNUSED(args);
	clear_screen();
}

void change_bg (char *args)
{
	set_background((args[0] - '0' ) * 28, (args[1] - '0') * 28, (args[2] - '0') * 28);
}

void halt_cpu(char *args)
{
	UNUSED(args);
	println("Shutting down the CPU. Goodbye.");
	__asm__ __volatile__("hlt");
}

void video_debug(char *args)
{
	UNUSED(args);
	char pitch_str[8];
	char width_str[8];
	char height_str[8];
	char bpp_str[8];
	char framebuffer_str[32];
	char rmask_str[8];
	char rpos_str[16];
	char gmask_str[8];
	char gpos_str[16];
	char bmask_str[8];
	char bpos_str[16];
	

	int_to_ascii(ADV_VBE_INFO->pitch, pitch_str);
	int_to_ascii(ADV_VBE_INFO->width, width_str);
	int_to_ascii(ADV_VBE_INFO->height, height_str);
	int_to_ascii(ADV_VBE_INFO->bpp, bpp_str);
	int_to_ascii(ADV_VBE_INFO->framebuffer, framebuffer_str);
	int_to_ascii(ADV_VBE_INFO->red_mask, rmask_str);
	int_to_ascii(ADV_VBE_INFO->red_position, rpos_str);
	int_to_ascii(ADV_VBE_INFO->green_mask, gmask_str);
	int_to_ascii(ADV_VBE_INFO->green_position, gpos_str);
	int_to_ascii(ADV_VBE_INFO->blue_mask, bmask_str);
	int_to_ascii(ADV_VBE_INFO->blue_position, bpos_str);

	println("VBE DEBUG INFORMATION");
	print("Pitch: ");
	println(pitch_str);
	print("Width: ");
	println(width_str);
	print("Height: ");
	println(height_str);
	print("BPP: ");
	println(bpp_str);
	print("Framebuffer: ");
	println(framebuffer_str);
	print("Red Mask: ");
	println(rmask_str);
	print("Green Mask: ");
	println(gmask_str);
	print("Blue Mask: ");
	println(bmask_str);
	print("Red Position: ");
	println(rpos_str);
	print("Green Position: ");
	println(gpos_str);
	print("Blue Posititon: ");
	println(bpos_str);
}

//DEBUGGING ONLY
/*void motor_control(char *args)
{
	if(args[0] == '0')
	{
		motor_off();
	}
	else
	{
		motor_on(0);
	}
	}*/

char *buffer;

void disk_cmd_init()
{
	buffer = (char *)malloc(0x4800);
}

void read_callback(int p)
{
	println(buffer);
	println(&buffer[0x3c47]);
	println("done");
	UNUSED(p);
}

void read_disk(char *args)
{
	UNUSED(args);
	
	floppy_read_track((args[0] - '0'), buffer, read_callback);
}

void write_callback(int p)
{
	UNUSED(p);
	println("done");
}

void write_disk(char *args)
{
	UNUSED(args);
	strcpy(buffer, "writing this text to the floppy");
	floppy_write_track((args[0]-'0'), buffer, write_callback);
}

void register_commands()
{
	register_command("help", help);
	register_command("echo", echo);
	register_command("clear", clear);
	register_command("bgc", change_bg);
	register_command("halt", halt_cpu);
	register_command("vinfo", video_debug);
	register_command("edit", editor);
	register_command("wd", write_disk);
	register_command("rd", read_disk);
}
